#!/usr/bin/env perl

# $Id: makeindex.pl,v 1.15 2004/05/29 09:43:00 bernisys Exp $

# include PERL libraries
use warnings;
use diagnostics;

# include HotSaNIC libraries
use lib "../../lib";
use lib "./platform";
use HotSaNICparser;
use HotSaNIChtml;
use common;

(my $VERSION = '$Revision: 1.15 $') =~ s/.*(\d+\.\d+).*/$1/;
(my $IDENTIFIER = '$Id: makeindex.pl,v 1.15 2004/05/29 09:43:00 bernisys Exp $') =~ s/.*,v (.*) \$/$1/;

# read global settings
#
$MODNAME=lc HotSaNICparser::get_module_name();
%CONFIG=HotSaNICparser::get_config("../..");
$IMAGEFORMAT=$CONFIG{IMAGEFORMAT};
$WEBDIR=$CONFIG{WEBDIR}."/".lc $MODNAME;
$VARDIR=$CONFIG{VARDIR}."/modules/".lc $MODNAME;
$REFRESH=$CONFIG{REFRESH};
$REFRESH=0 if !defined $REFRESH;

%MODCONFIG=HotSaNICmod::common::configure();
@DIAGRAMS=("hour","6h","day","week","month","year");
@TIMES=("6h","week");

# build time-based .html files
#
foreach $time (@TIMES) {
  open (FILE,">$WEBDIR/$time.html");
  print FILE HotSaNIChtml::create_header($MODNAME,$REFRESH,"$time overview page")."<table>\n";
  foreach $entry (@{$MODCONFIG{DEV}}) {
    my (undef,undef,undef,undef,$name,$file,$description)=HotSaNICmod::common::get_names($entry);
    print FILE HotSaNIChtml::create_table_entry($IMAGEFORMAT,$file,$time,$name,$description,1);
    }
  print FILE "</table>\n".HotSaNIChtml::create_footer($MODNAME);
  close FILE;
  }

# build device-based .html files and complete index
#
open (IDXFILE,">$VARDIR/idxdata");
print IDXFILE HotSaNIChtml::create_overview_table_header($MODNAME,join(" ",@TIMES),1);
$num=0;
foreach $entry (@{$MODCONFIG{DEV}}) {
  my (undef,undef,undef,undef,$name,$file,$description)=HotSaNICmod::common::get_names($entry);
  $num++;
  print IDXFILE HotSaNIChtml::create_overview_table_entry($MODNAME,$IMAGEFORMAT,$num,$file,$name,$description);
  HotSaNIChtml::make_device_page($MODNAME,$WEBDIR,$IMAGEFORMAT,$file,$description,@DIAGRAMS);
  }

close IDXFILE;

