#!/usr/bin/env perl

# $Id: makeindex.pl,v 1.13 2004/05/29 09:43:00 bernisys Exp $

# include PERL libraries
use warnings;
use diagnostics;

# include HotSaNIC libraries
use lib "../../lib";

use HotSaNICparser;
use HotSaNIChtml;


(my $VERSION = '$Revision: 1.13 $') =~ s/.*(\d+\.\d+).*/$1/;
(my $IDENTIFIER = '$Id: makeindex.pl,v 1.13 2004/05/29 09:43:00 bernisys Exp $') =~ s/.*,v (.*) \$/$1/;

# read global settings
#
$MODNAME=lc HotSaNICparser::get_module_name();
%CONFIG=HotSaNICparser::get_config("../..");
$IMAGEFORMAT=$CONFIG{IMAGEFORMAT};
$WEBDIR=$CONFIG{WEBDIR}."/".lc $MODNAME;
$VARDIR=$CONFIG{VARDIR}."/modules/".lc $MODNAME;
$REFRESH=$CONFIG{REFRESH};
$REFRESH=0 if !defined $REFRESH;


@DIAGRAMS=("week","month","year");
@TIMES=("month","year");

# build time-based .html files
#
@DEVS=("rc5","ogr","des","csc");
foreach $time (@TIMES) {
  open (FILE,">$WEBDIR/$time.html");
  print FILE HotSaNIChtml::create_header($MODNAME,$REFRESH,"$time overview page")."<table>\n";
  foreach $dev (@DEVS) {
    print FILE HotSaNIChtml::create_table_entry($IMAGEFORMAT,$dev,$time,$dev,"",1);
    }
  print FILE "</table>\n".HotSaNIChtml::create_footer($MODNAME);
  close FILE;
  }

# build device-based .html files and complete index
#
open (IDXFILE,">$VARDIR/idxdata");
print IDXFILE HotSaNIChtml::create_overview_table_header($MODNAME,join(" ",@TIMES),1);
$num=0;
foreach $dev (@DEVS) {
  $num++;
  print IDXFILE HotSaNIChtml::create_overview_table_entry($MODNAME,$IMAGEFORMAT,$num,$dev,$dev,"");
  HotSaNIChtml::make_device_page($MODNAME,$WEBDIR,$IMAGEFORMAT,$dev,$dev,@DIAGRAMS);
  }

close IDXFILE;

